const express = require('express');

function createRouter(db) {
    const router = express.Router();

    // the routes are defined here

    //Generate new Session
    router.post('/addSession', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'INSERT INTO Session (SessionName) VALUES (\"'+spielname+'\");',
                error => {
                    if (error) {
                        console.error(error);
                        res.status(500).json({status: 'false'});
                    }
                }
            );
            //Init new Gamestatus
            db.query(
                'INSERT INTO Gamestatus (SessionID, Red, Blue, RedTurn, ActiveExplainer, ActiveWatchdog) VALUES ((SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\"), 0, 0, 1, 0, 0);',
                error => {
                    if (error) {
                        console.error(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json({status: 'true'});
                    }
                });
        } else {
            res.status(500).json({status: 'error'});
        }
    });

    //Check if Session exist
    router.post('/isSession', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'SELECT SessionName FROM Session WHERE SessionName = \''+spielname+'\';',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'error'});
                    } else {
                        if (results.length > 0) {
                            res.status(200).json({status: 'true'});
                        } else {
                            res.status(200).json({status: 'false'});
                        }
                    }
                }
            );
        } else {
            res.status(500).json({status: 'error'});
        }
    });

    //Return all Sessions (Not neccesary)
    router.get('/Session', function (req, res) {
        db.query(
            'SELECT * FROM Session',
            (error, results) => {
                if (error) {
                    console.log(error);
                    res.status(500).json({status: 'error'});
                } else {
                    res.status(200).json(results);
                }
            }
        );
    });

    //Return GameStatus
    router.post('/getGamestatus', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'SELECT SessionID, Red, Blue, RedTurn, ActiveExplainer, ActiveWatchdog FROM Gamestatus WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json(
                            {
                                status: 'true',
                                sessionID: results[0].SessionID,
                                red: results[0].Red,
                                blue: results[0].Blue,
                                redTurn: results[0].RedTurn,
                                activeExplainer: results[0].ActiveExplainer,
                                activeWatchdog: results[0].ActiveWatchdog
                            }
                        );
                    }
                }
            );
        } else {
            res.status(500).json({status: 'error'});
        }
    });

    //Start a new Round and lock the game positions
    router.post('/newRound', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'UPDATE Gamestatus SET ActiveExplainer = 1, ActiveWatchdog=1 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json({status: 'true'});
                    }
                }
            );
        } else {
            res.status(500).json({status: 'false'});
        }
    });

    //End a Round and unlock the game positions and invert RedTurn
    router.post('/endRound', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'UPDATE Gamestatus SET RedTurn = (SELECT 1-Gamestatus.RedTurn FROM Gamestatus INNER JOIN Session ON Session.SessionID=Gamestatus.SessionID WHERE Session.SessionName = \"'+spielname+'\"),  ActiveExplainer = 0, ActiveWatchdog=0 WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json({status: 'true'});
                    }
                }
            );
        } else {
            res.status(500).json({status: 'false'});
        }
    });

    //Starts a new Game and resets red and blue and chooses a random value for RedTurn
    router.post('/newGame', (req, res) => {
        const spielname = req.body.spielname;
        if (spielname.match(/^[0-9a-zA-Z]+$/) != null) {
            db.query(
                'UPDATE Gamestatus SET Red = 0, Blue = 0, RedTurn = '+Math.round(Math.random())+' WHERE SessionID = (SELECT SessionID FROM Session WHERE SessionName = \"'+spielname+'\")',
                (error, results) => {
                    if (error) {
                        console.log(error);
                        res.status(500).json({status: 'false'});
                    } else {
                        res.status(200).json({status: 'true'});
                    }
                }
            );
        } else {
            res.status(500).json({status: 'false'});
        }
    });

    return router;
}

module.exports = createRouter;
